part of polarizelab.ui;

class Card extends StatelessWidget {
  final Widget child;
  final Color startColor;
  final Color endColor;
  final bool visible;
  final double elevation;
  final Color shadowColor;
  final double radius;
  Card(
      {@required this.child,
      this.startColor,
      this.endColor,
      this.elevation = 4,
      this.visible = true,
      this.shadowColor = const Color(0xff757de8),
      this.radius = 4});
  @override
  Widget build(BuildContext context) {
    return Container(
      child: child,
      decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(radius),
          gradient: LinearGradient(
              colors: [
                startColor ?? Theme.of(context).backgroundColor,
                endColor ?? Theme.of(context).backgroundColor
              ],
              begin: Alignment.topLeft,
              end: Alignment.bottomRight,
              tileMode: TileMode.repeated),
          boxShadow: visible
              ? <BoxShadow>[
                  BoxShadow(
                      color: shadowColor.withAlpha(0x80),
                      blurRadius: elevation,
                      spreadRadius: 0)
                ]
              : []),
    );
  }
}
