part of polarizelab.ui;

class Carousel extends StatefulWidget {
  final int itemCount;
  final Widget Function(BuildContext context, int index) builder;
  final Widget Function(BuildContext context, int index) dotBuilder;
  final Widget Function(BuildContext context, int index) selectedDotBuilder;
  final EdgeInsets dotPadding;
  @override
  State<StatefulWidget> createState() => _CarouselState();
  Carousel.builder(
      {@required this.itemCount,
      @required this.builder,
      this.dotBuilder,
      this.selectedDotBuilder,
      this.dotPadding = const EdgeInsets.all(0)});
}

class _CarouselState extends State<Carousel> {
  final PageController _controller = PageController(viewportFraction: 0.6);
  int _page = 0;
  final Widget Function(BuildContext context, int index) _defaultDotBuilder =
      (context, index) => Icon(Icons.fiber_manual_record,
          size: 12, color: Theme.of(context).colorScheme.primary.withAlpha(0x60));
  final Widget Function(BuildContext context, int index)
      _defaultSelectedDotBuilder = (context, index) => Icon(
            Icons.fiber_manual_record,
            size: 12,
            color: Theme.of(context).colorScheme.primary,
          );
  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[
        PageView(
          controller: _controller,
          onPageChanged: (page) {
            setState(() {
              _page = page;
            });
          },
          children: Iterable<int>.generate(widget.itemCount).map((index) {
            return widget.builder(context, index);
          }).toList(),
        ),
        Padding(
          padding: widget.dotPadding,
          child: Align(
            alignment: Alignment.bottomCenter,
            child: Row(
              mainAxisSize: MainAxisSize.min,
              children: Iterable<int>.generate(widget.itemCount).map((index) {
                return index == _page
                    ? (widget.selectedDotBuilder ?? _defaultSelectedDotBuilder)(
                        context, index)
                    : (widget.dotBuilder ?? _defaultDotBuilder)(context, index);
              }).toList(),
            ),
          ),
        )
      ],
    );
  }
}
