part of polarizelab.ui;

class NumericUpDown extends StatefulWidget {
  final int value;
  final Color stepColor;
  final Color valueColor;
  final double spacing;
  final Color stepBackgroundColor;
  final double radius;
  final Function(int) onValueChanged;
  NumericUpDown(
      {@required this.value,
      this.stepColor,
      this.valueColor,
      this.spacing = 12,
      this.stepBackgroundColor,
      this.radius = 4,
      this.onValueChanged});
  @override
  State<StatefulWidget> createState() {
    return _NumericUpDownState(this.value);
  }
}

class _NumericUpDownState extends State<NumericUpDown> {
  int _value;
  _NumericUpDownState(this._value);
  @override
  Widget build(BuildContext context) {
    return Container(
      child: Row(
        mainAxisSize: MainAxisSize.min,
        children: <Widget>[
          Padding(
            padding: EdgeInsets.only(right: widget.spacing),
            child: Container(
              decoration: BoxDecoration(
                  color: widget.stepBackgroundColor ??
                      Theme.of(context).colorScheme.onBackground,
                  borderRadius:
                      BorderRadius.all(Radius.circular(widget.radius))),
              child: InkWell(
                child: Icon(Icons.remove,
                    color: widget.stepColor ??
                        Theme.of(context).colorScheme.primaryVariant),
                onTap: _decrease,
              ),
            ),
          ),
          Text(
            _value.toString(),
            style: TextStyle(
                color: widget.valueColor ??
                    Theme.of(context).colorScheme.primaryVariant),
          ),
          Padding(
            padding: EdgeInsets.only(left: widget.spacing),
            child: Container(
              decoration: BoxDecoration(
                  color: widget.stepBackgroundColor ??
                      Theme.of(context).colorScheme.onBackground,
                  borderRadius:
                      BorderRadius.all(Radius.circular(widget.radius))),
              child: InkWell(
                child: Icon(Icons.add,
                    color: widget.stepColor ??
                        Theme.of(context).colorScheme.primaryVariant),
                onTap: _increase,
              ),
            ),
          ),
        ],
      ),
    );
  }

  _decrease() {
    setState(() {
      _value = _value > 0 ? _value - 1 : 0;
    });
    if (widget.onValueChanged != null) widget.onValueChanged(_value);
  }

  _increase() {
    setState(() {
      _value++;
    });
    if (widget.onValueChanged != null) widget.onValueChanged(_value);
  }
}
