part of polarizelab.ui;

class TitleWidget extends StatelessWidget {
  final String text;
  final bool hasBack;
  final Color backColor;
  final Color textColor;
  final TextStyle textStyle;
  final TextAlign textAlign;
  final Widget rightWidget;
  final EdgeInsets padding;
  TitleWidget(
      {@required this.text,
      this.textColor,
      this.hasBack = true,
      this.backColor,
      this.textStyle,
      this.textAlign = TextAlign.center,
      this.rightWidget,
      this.padding =
          const EdgeInsets.only(left: 24, top: 16, bottom: 8, right: 24)});
  @override
  Widget build(BuildContext context) {
    final bool canBack = Navigator.of(context)
        .canPop(); // Todo: Need to check current index of page
    return Padding(
      child: Stack(
        alignment: Alignment.center,
        children: <Widget>[
          Align(
            alignment: Alignment.centerLeft,
            child: canBack && hasBack
                ? CircleButton(
                    icon: Icon(
                      Icons.arrow_back_ios,
                      color: backColor ??
                          Theme.of(context).colorScheme.primaryVariant,
                    ),
                    onPressed: () {
                      Navigator.of(context).pop();
                    },
                    hasShadow: false,
                    size: 24,
                  )
                : Container(),
          ),
          Text(
            this.text,
            style: textStyle ?? Theme.of(context).textTheme.headline,
            textAlign: textAlign,
          ),
          Align(
            child: rightWidget ?? Container(),
            alignment: Alignment.centerRight,
          )
        ],
      ),
      padding: padding,
    );
  }
}
